/*
 * Copyright (c) 2014 Intel Corporation. All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef SMIAPP_QUIRK_REG_H
#define SMIAPP_QUIRK_REG_H

#define SMIAPP_IMX135_REG_U8_CSI_LANE_MODE		SMIAPP_REG_MK_U8(0x0108)
#define SMIAPP_IMX135_REG_U8_CSI_CH_ID			SMIAPP_REG_MK_U8(0x0110)
#define SMIAPP_IMX135_REG_U8_TEMP_SEN_CTL		SMIAPP_REG_MK_U8(0x0220)
#define SMIAPP_IMX135_U8_TEMP_SEN_CTL_ENABLE		0x01
#define SMIAPP_IMX135_REG_U16_EXTCLK_FREQUENCY_MHZ	SMIAPP_REG_MK_U16(0x011e)
#define SMIAPP_IMX135_REG_U8_VT_PIX_CLK_DIV		SMIAPP_REG_MK_U8(0x0301)
#define SMIAPP_IMX135_REG_U8_VT_SYS_CLK_DIV		SMIAPP_REG_MK_U8(0x0303)
#define SMIAPP_IMX135_REG_U8_OP_PIX_CLK_DIV		SMIAPP_REG_MK_U8(0x0309)
#define SMIAPP_IMX135_REG_U8_OP_SYS_CLK_DIV		SMIAPP_REG_MK_U8(0x030b)
#define SMIAPP_IMX135_REG_U16_PLL_OP_MULTIPLIER		SMIAPP_REG_MK_U16(0x030c)
#define SMIAPP_IMX135_REG_U8_PLL_SOLO_DRIVE		SMIAPP_REG_MK_U8(0x030e)
#define SMIAPP_IMX135_U8_PLL_SOLO_DRIVE_SINGLE_PLL	0x01
#define SMIAPP_IMX135_REG_U16_DIG_CROP_X_START		SMIAPP_REG_MK_U16(0x0350)
#define SMIAPP_IMX135_REG_U16_DIG_CROP_Y_START		SMIAPP_REG_MK_U16(0x0352)
#define SMIAPP_IMX135_REG_U16_DIG_CROP_X_SIZE		SMIAPP_REG_MK_U16(0x0354)
#define SMIAPP_IMX135_REG_U16_DIG_CROP_Y_SIZE		SMIAPP_REG_MK_U16(0x0356)
#define SMIAPP_IMX135_REG_U8_BINNING_MODE		SMIAPP_REG_MK_U8(0x0390)
#define SMIAPP_IMX135_REG_U8_BINNING_TYPE		SMIAPP_REG_MK_U8(0x0391)
#define SMIAPP_IMX135_REG_U8_BINNING_WEIGHTING		SMIAPP_REG_MK_U8(0x0392)
#define SMIAPP_IMX135_REG_U8_TCLK_POST			SMIAPP_REG_MK_U8(0x0830)
#define SMIAPP_IMX135_REG_U8_THS_PREPARE		SMIAPP_REG_MK_U8(0x0831)
#define SMIAPP_IMX135_REG_U8_THS_ZERO_MIN		SMIAPP_REG_MK_U8(0x0832)
#define SMIAPP_IMX135_REG_U8_THS_TRAIL			SMIAPP_REG_MK_U8(0x0833)
#define SMIAPP_IMX135_REG_U8_TCLK_TRAIL_MIN		SMIAPP_REG_MK_U8(0x0834)
#define SMIAPP_IMX135_REG_U8_TCLK_PREPARE		SMIAPP_REG_MK_U8(0x0835)
#define SMIAPP_IMX135_REG_U8_TCLK_ZERO			SMIAPP_REG_MK_U8(0x0836)
#define SMIAPP_IMX135_REG_U8_TLPX			SMIAPP_REG_MK_U8(0x0837)
#define SMIAPP_IMX135_REG_U8_TCLK_PRE			SMIAPP_REG_MK_U8(0x0839)
#define SMIAPP_IMX135_REG_U8_TCLK_EXIT			SMIAPP_REG_MK_U8(0x083a)
#define SMIAPP_IMX135_REG_U8_TLPXESC			SMIAPP_REG_MK_U8(0x083b)
#define SMIAPP_IMX135_REG_U8_DIV			SMIAPP_REG_MK_U8(0x3a06)
/* SRC2DIV: Use the same value as SMIAPP_REG_U16_OP_SYS_CLK_DIV */
#define SMIAPP_IMX135_U8_DIV_SRC2DIV_MASK		0x03
#define SMIAPP_IMX135_U8_DIV_SRC2DIV_SHIFT		0
#define SMIAPP_IMX135_U8_DIV_SRC2DIV_1			1
#define SMIAPP_IMX135_U8_DIV_SRC2DIV_2			2
#define SMIAPP_IMX135_U8_DIV_CKDIV_MODE_MASK		0x10
#define SMIAPP_IMX135_U8_DIV_CKDIV_MODE_MANUAL		0x10
#define SMIAPP_IMX135_REG_U16_WRITE_HSIZE		SMIAPP_REG_MK_U16(0x3310)
#define SMIAPP_IMX135_REG_U16_WRITE_VSIZE		SMIAPP_REG_MK_U16(0x3312)
#define SMIAPP_IMX135_REG_U16_SCL_BYPASS		SMIAPP_REG_MK_U16(0x4082)
#define SMIAPP_IMX135_U16_SCL_BYPASS_ENABLE		0x11

#endif /* SMIAPP_QUIRK_REG_H */
